from os.path import exists
from typing import TextIO
import re

def open_file(remove:bool)->TextIO:
    nf = open("output.txt", 'x' if not exists("./output.txt") else 'w')
    nf.write(f"[{'+' if remove else '-'}] algs that match...\n")
    return nf

# example regex:
p_ex = r'(-5,4)+|(6,-3)+|(6,3)+|(3,6)+|(-3,6)+|(5,2)+|(-5,-2)+|(5,2)+|(4,-5)+|(-4,5)+|(5,-4)(-5,4)+'
p_inc = r'^-?\d,-?\d/[(1,1)(-1,-1)(1,4)(-1,-4)(2,-1)(-2,1)(1,-2)(-1,2)]+  \[[^\]]*\][\s\S]$'

def filter(remove:bool, regex:str):
    nf = open_file(remove)
    # input is the output from https://www.jaapsch.net/puzzles/square1.htm#progs
    with open("in.txt", 'r', encoding='utf-8') as f:
        if not remove:
            [nf.write(l) if (not re.search(r'(Nodes=*)', l) and not re.search(regex, l)) else True for l in f]
        else:
            [nf.write(l) if ((not re.search(r'(Nodes=*)', l)) and re.search(regex, l)) else True for l in f]

    nf.close()


s = int(input("0: filter out, 1: filter for\t"))

# example usage
filter(s, p_inc if s else p_ex)